# Scanorama

- [API example usage](#api-example-usage)
- [Full tutorial](#full-tutorial)
- [Installation](#installation)
- [Testing](#testing)
- [Troubleshooting](#troubleshooting)

## Overview

Scanorama enables batch-correction and integration of heterogeneous scRNA-seq datasets, which is described in the paper ["Efficient integration of heterogeneous single-cell transcriptomes using Scanorama"](https://www.nature.com/articles/s41587-019-0113-3) by Brian Hie, Bryan Bryson, and Bonnie Berger. This repository contains the Scanorama source code as well as scripts necessary for reproducing the results in the paper.

Scanorama is designed to be used in scRNA-seq pipelines downstream of noise-reduction methods, including those for imputation and highly-variable gene filtering. The results from Scanorama integration and batch correction can then be used as input to other tools for scRNA-seq clustering, visualization, and analysis.

Tools for data sketching can also greatly accelerate Scanorama integration, as described in the paper ["Geometric sketching compactly summarizes the single-cell transcriptomic landscape"](https://www.cell.com/cell-systems/fulltext/S2405-4712\(19\)30152-8) and implemented [here](https://github.com/brianhie/geosketch).

## API example usage

**Scanorama is part of [Scanpy's external API](https://scanpy.readthedocs.io/en/stable/external/scanpy.external.pp.scanorama_integrate.html#scanpy.external.pp.scanorama_integrate).** Consider using this API for easy integration with Scanpy.

Alternatively, parameter documentation using the base Scanorama package is provided in the Scanorama source code at the top of [`scanorama/scanorama.py`](scanorama/scanorama.py).

Here is example usage of Scanorama in Python:

```Python
# List of datasets (matrices of cells-by-genes):
datasets = [ list of scipy.sparse.csr_matrix or numpy.ndarray ]
# List of gene lists:
genes_list = [ list of list of string ]

import scanorama

# Integration.
integrated, genes = scanorama.integrate(datasets, genes_list)

# Batch correction.
corrected, genes = scanorama.correct(datasets, genes_list)

# Integration and batch correction.
integrated, corrected, genes = scanorama.correct(datasets, genes_list, return_dimred=True)
```

There are also wrappers that make it easy to use Scanorama with [scanpy's AnnData object](https://anndata.readthedocs.io/en/latest/anndata.AnnData.html#anndata.AnnData):

```Python
# List of datasets:
adatas = [ list of scanpy.AnnData ]

import scanorama

# Integration.
scanorama.integrate_scanpy(adatas)

# Batch correction.
corrected = scanorama.correct_scanpy(adatas)

# Integration and batch correction.
corrected = scanorama.correct_scanpy(adatas, return_dimred=True)
```
The function `integrate_scanpy()` will simply add an entry into `adata.obsm` called `'X_scanorama'` for each `adata` in `adatas`. `obsm['X_scanorama']` contains the low dimensional embeddings as a result of integration, which can be used for KNN graph construction, visualization, and other downstream analysis.
The function `correct_scanpy()` is a little more involved -- it will create new `AnnData` objects and replace `adata.X` with the Scanorama-transformed cell-by-gene matrix, while keeping the other metadata in `adata` as well.

You can also call Scanorama from R using the [`reticulate`](https://rstudio.github.io/reticulate/) package (tested with R version 3.5.1 and reticulate version 1.10):

```R
# List of datasets (matrices of cells-by-genes):
datasets <- list( list of matrix )
# List of gene lists:
genes_list <- list( list of list of string )

library(reticulate)
scanorama <- import('scanorama')

# Integration.
integrated.data <- scanorama$integrate(datasets, genes_list)

# Batch correction.
corrected.data <- scanorama$correct(datasets, genes_list, return_dense=TRUE)

# Integration and batch correction.
integrated.corrected.data <- scanorama$correct(datasets, genes_list,
                                               return_dimred=TRUE, return_dense=TRUE)
```

Note that `reticulate` has trouble returning sparse matrices, so you should set the `return_dense` flag to `TRUE` (which returns the corrected data as R `matrix` objects) when attempting to use Scanorama's `correct()` method in R. This will increase memory usage, however, especially for very large datasets.

## Full tutorial

For step-by-step tutorials on how Scanorama can integrate into a full single-cell analysis pipeline, there are a few excellent resources made available by the community of Scanorama users.

Here is a simple exercise for integrating three PBMC scRNA-seq datasets (by Åsa Björklund and Paulo Czarnewski):
https://nbisweden.github.io/workshop-scRNAseq/labs/compiled/scanpy/scanpy_03_integration.html

Here is a more advanced exercise for integrating scRNA-seq Visium spatial data (by Giovanni Palla):
https://scanpy-tutorials.readthedocs.io/en/latest/spatial/integration-scanorama.html

Our gratitude goes out to the creators of these tutorials!

## Installation

### Setup

You should be able to download Scanorama using `pip`:
```
pip install scanorama
```

If for some reason this doesn't work, you can also install from within the Scanorama repository:
```
git clone https://github.com/brianhie/scanorama.git
cd scanorama/
python setup.py install --user
```

If you are running inside an anaconda environment, first install annoy by doing:
```
conda install -c conda-forge python-annoy
```

## Examples from paper

### Dataset download

All of the data used in our study (around 4 GB) can be downloaded from http://scanorama.csail.mit.edu/data.tar.gz. Download and unpack this data with the command:

```
wget http://scanorama.csail.mit.edu/data.tar.gz
tar xvf data.tar.gz
```

A smaller version of the data (around 720 MB), including 26 heterogeneous datasets, can be similarly downloaded from http://scanorama.csail.mit.edu/data_light.tar.gz.

### Data processing

The script `bin/process.py` can handle two file formats. The first is a tab-delimited table format where the columns correspond to cells and the rows correspond to genes. A sample file looks something like:
```
gene	cell_a	cell_b
gene_1	10	10
gene_2	20	20
```
The second is a sparse matrix format used by 10X Genomics (example [here](http://cf.10xgenomics.com/samples/cell-exp/1.1.0/293t/293t_filtered_gene_bc_matrices.tar.gz)). This format has a directory where one file has a list of gene names (`genes.tsv`) and one file has a list of the nonzero transcript counts at certain gene/cell coordinates (`matrix.mtx`).

To ensure a consistent data format, the examples first processes these raw files and saves them in `.npz` files along with some related metadata. To generate these files, run the command:
```
python bin/process.py conf/panorama.txt
```
The corresponding `.npz` files will be saved in the `data/` directory.

New files can be processed by feeding them into `bin/process.py` via the command line or a configuration file, or by modifying the `data_names` variables at the top of `bin/config.py`.

### Panorama stitching

#### Toy datasets

For a good illustration of how Scanorama works, we can integrate three toy datasets: 293T cells, Jurkat cells, and a 50:50 293T:Jurkat mixture. To integrate these datasets, run:
```
python bin/293t_jurkat.py
```
By default, this prints a log reporting the alignments the algorithm has found between datasets and saves visualization images to a file in the repository's top-level directory.

#### 26 datasets

We can also stitch a much larger number of cells from many more datsets. To do this, run
```
python bin/integration_panorama.py conf/panorama.txt
```
to integrate the datasets or
```
python bin/panorama.py conf/panorama.txt
```
to batch correct the datasets as well. The collection of datasets to be integrated is specified in the config file `conf/panorama.txt`. Default parameters are listed at the top of `scanorama/scanorama.py`.

By default, this script will output a verbose log as it finds alignments and applies batch correction. At the end, it will automatically save t-SNE visualized images of the integrated result. The numpy matrices containing the batch-corrected datasets are also available (in memory) to integrate with other single cell pipelines and packages.

#### Runtime performance and memory requirements

Scanorama runs on multiple cores to speed up its computation; [here are some instructions](https://roman-kh.github.io/numpy-multicore/) to check if Python is making use of the benefits from multicore processing. Aligning and batch-correcting 105,476 cells across 26 datasets should complete in around 15 minutes with the process running on 10 cores. The memory usage should be under 8 GB for integration and under 26 GB for batch correction.

Note that the gradient descent portion of the t-SNE visualization step can take a very long time (a few hours) and require a lot of memory (around 30 GB) on more than 100k cells. Other methods for accelerating t-SNE could be used in place of the t-SNE implementation used in this pipeline, such as a faster C++ implementation of [t-SNE](https://github.com/lvdmaaten/bhtsne), [Multicore-TSNE](https://github.com/DmitryUlyanov/Multicore-TSNE), or [net-SNE](https://github.com/hhcho/netsne), a version of t-SNE that uses a neural network to reduce the time required for the gradient descent optimization procedure.

#### Additional analyses from paper

Scripts for performing additional analyses of the data are also available in the `bin/` directory.

## Scanorama implementation

For those interested in the algorithm implementation, `scanorama/scanorama.py` is the main file that handles the mutual nearest neighbors-based matching, batch correction, and panorama assembly.

## Testing

Unit tests require using [pytest](https://docs.pytest.org/en/latest/) and can be run with the command
```
python -m pytest tests
```
from the top-level directory.

## Troubleshooting

- Make sure the input matrices are cells-by-genes, not the transpose.

- For large dataset integration under memory constraints (e.g., if you run into a `MemoryError`), try lowering the `batch_size` parameter to improve memory usage and try sketch-based acceleration using the `sketch` parameter to `integrate()` to improve both memory usage and runtime.

- Some users report "Illegal instruction" or "Segfault" errors using the most recent versions of the `annoy` package; Scanorama is tested with `annoy` version 1.11.5 on Ubuntu 18.04. To fix, pass `approx=False` to use scikit-learn's nearest neighbors matching.

- For the example scripts, be sure to run `bin/process.py` first, although this is not necessary if you are using Scanorama through the API.

## Questions

For questions about the pipeline and code, contact brianhie@mit.edu. We will do our best to provide support, address any issues, and keep improving this software. And do not hesitate to submit a pull request and contribute!

library(methods)
library(Seurat)

names = list(
    "../../data/293t_jurkat/293t_table.txt",
    "../../data/293t_jurkat/jurkat_table.txt",
    "../../data/293t_jurkat/jurkat_293t_50_50_table.txt",
    "../../data/293t_jurkat/jurkat_293t_99_1_table.txt",
    "../../data/brain/neuron_9k_table.txt",
    "../../data/macrophage/gmcsf_table.txt",
    "../../data/macrophage/infected_table.txt",
    "../../data/macrophage/mcsf_table.txt",
    "../../data/macrophage/uninfected_table.txt",
    "../../data/marrow/marrow_mars_table.txt",
    "../../data/marrow/marrow_ss2_table.txt",
    "../../data/pancreas/pancreas_human_table.txt",
    "../../data/pancreas/pancreas_multi_celseq2_expression_matrix_table.txt",
    "../../data/pancreas/pancreas_multi_celseq_expression_matrix_table.txt",
    "../../data/pancreas/pancreas_multi_fluidigmc1_expression_matrix_table.txt",
    "../../data/pancreas/pancreas_multi_smartseq2_expression_matrix_table.txt",
    "../../data/pbmc/10x/68k_pbmc_table.txt",
    "../../data/pbmc/10x/b_cells_table.txt",
    "../../data/pbmc/10x/cd14_monocytes_table.txt",
    "../../data/pbmc/10x/cd4_t_helper_table.txt",
    "../../data/pbmc/10x/cd56_nk_table.txt",
    "../../data/pbmc/10x/cytotoxic_t_table.txt",
    "../../data/pbmc/10x/memory_t_table.txt",
    "../../data/pbmc/10x/regulatory_t_table.txt",
    "../../data/pbmc/immune_control_expression_matrix_table.txt",
    "../../data/pbmc/pbmc_10X_table.txt"
)

data.tables <- list()
for (i in 1:length(names)) {
    data.tables[[i]] <- as(as.matrix(
        read.table(names[[i]])
    ), "dgCMatrix")
}

ob.list <- list()
for (i in 1:length(names)) {
    ob.list[[i]] <- CreateSeuratObject(raw.data = data.tables[[i]])
    ob.list[[i]] <- NormalizeData(ob.list[[i]])
    ob.list[[i]] <- FilterCells(ob.list[[i]], subset.names = "nGene", low.thresholds = 1)
    ob.list[[i]] <- FindVariableGenes(ob.list[[i]], do.plot = F, display.progress = F)
    ob.list[[i]] <- ScaleData(ob.list[[i]])
    ob.list[[i]]@meta.data$tech <- toString(i)
}

print("Done loading")

genes.use <- c()
for (i in 1:length(ob.list)) {
  genes.use <- c(genes.use, head(rownames(ob.list[[i]]@hvg.info), 100000))
}
genes.use <- names(which(table(genes.use) > 1))
for (i in 1:length(ob.list)) {
  genes.use <- genes.use[genes.use %in% rownames(ob.list[[i]]@scale.data)]
}

print("Done intersecting genes")

ptm <- proc.time()

integrated <- RunMultiCCA(ob.list, genes.use = genes.use, num.ccs = 15)

print("CCA Done")

# CC Selection
#MetageneBicorPlot(integrated, grouping.var = "tech", dims.eval = 1:15)

# Run rare non-overlapping filtering
#integrated <- CalcVarExpRatio(object = integrated, reduction.type = "pca",
#                                       grouping.var = "tech", dims.use = 1:15)
#integrated <- SubsetData(integrated, subset.name = "var.ratio.pca",
#                         accept.low = 0.5)

# Alignment
integrated <- AlignSubspace(integrated,
                            reduction.type = "cca",
                            grouping.var = "tech",
                            dims.align = 1:15)

print(proc.time() - ptm)

write.table(integrated@dr$cca@cell.embeddings,
            file = "../data/corrected_seurat.txt",
            quote = FALSE, sep = "\t")

suppressMessages(library(monocle))

# Pseudo-time for uncorrected.

expr.matrix <- as.matrix(read.table("data/macrophage/mono_macro_table.txt"))
sample.sheet <- read.table("data/macrophage/mono_macro_meta.txt")
gene.annotation <- read.delim("data/macrophage/mono_macro_genes.txt")

pd <- new("AnnotatedDataFrame", data = sample.sheet)
fd <- new("AnnotatedDataFrame", data = gene.annotation)
obj <- newCellDataSet(expr.matrix, phenoData = pd, featureData = fd,
                      expressionFamily=tobit())

orderingGenes <- scan("data/macrophage/mono_macro_diffexpr_uncorrected.txt",
                      what = typeof(""), sep = "\n")
obj <- setOrderingFilter(obj, orderingGenes)

obj <- reduceDimension(obj, max_components = 2, method = 'DDRTree')

obj <- orderCells(obj)

pdf('uncorrected.pdf')

plot_cell_trajectory(obj, color_by = "Batch", cell_size = 3)

# Pseudo-time for corrected.

expr.matrix <- as.matrix(read.table("data/macrophage/mono_macro_corrected_table.txt"))
sample.sheet <- read.table("data/macrophage/mono_macro_meta.txt")
gene.annotation <- read.delim("data/macrophage/mono_macro_genes.txt")

pd <- new("AnnotatedDataFrame", data = sample.sheet)
fd <- new("AnnotatedDataFrame", data = gene.annotation)
obj <- newCellDataSet(expr.matrix, phenoData = pd, featureData = fd,
                      expressionFamily=tobit())

orderingGenes <- scan("data/macrophage/mono_macro_diffexpr_scanorama.txt",
                      what = typeof(""), sep = "\n")
obj <- setOrderingFilter(obj, orderingGenes)

obj <- reduceDimension(obj, max_components = 2, method = 'DDRTree')

obj <- orderCells(obj)

pdf('corrected.pdf')

plot_cell_trajectory(obj, color_by = "Batch", cell_size = 3)

# Pseudo-time for scran MNN.

expr.matrix <- as.matrix(read.table("data/macrophage/mono_macro_mnn_corrected_table.txt"))
sample.sheet <- read.table("data/macrophage/mono_macro_meta.txt")
gene.annotation <- read.delim("data/macrophage/mono_macro_genes.txt")

pd <- new("AnnotatedDataFrame", data = sample.sheet)
fd <- new("AnnotatedDataFrame", data = gene.annotation)
obj <- newCellDataSet(expr.matrix, phenoData = pd, featureData = fd,
                      expressionFamily=tobit())

orderingGenes <- scan("data/macrophage/mono_macro_diffexpr_mnn.txt",
                      what = typeof(""), sep = "\n")
obj <- setOrderingFilter(obj, orderingGenes)

obj <- reduceDimension(obj, max_components = 2, method = 'DDRTree')

obj <- orderCells(obj)

pdf('mnn_corrected.pdf')

plot_cell_trajectory(obj, color_by = "Batch", cell_size = 3)

library(methods)
library(scran)

names = list(
    "data/pancreas/pancreas_inDrop_table.txt",
    "data/pancreas/pancreas_multi_celseq2_expression_matrix_table.txt",
    "data/pancreas/pancreas_multi_celseq_expression_matrix_table.txt",
    "data/pancreas/pancreas_multi_fluidigmc1_expression_matrix_table.txt",
    "data/pancreas/pancreas_multi_smartseq2_expression_matrix_table.txt"
)

data.tables <- list()
for (i in 1:length(names)) {
    data.tables[[i]] <- as.matrix(
        read.table(names[[i]], sep="\t")
    )
}

print("Done loading")

ptm <- proc.time()

Xmnn <- mnnCorrect(
    data.tables[[1]],
    data.tables[[2]],
    data.tables[[3]],
    data.tables[[4]],
    data.tables[[5]]#,
    #data.tables[[6]],
    #data.tables[[7]],
    #data.tables[[8]],
    #data.tables[[9]],
    #data.tables[[10]],
    #data.tables[[11]],
    #data.tables[[12]],
    #data.tables[[13]],
    #data.tables[[14]],
    #data.tables[[15]],
    #data.tables[[16]],
    #data.tables[[17]],
    #data.tables[[18]],
    #data.tables[[19]],
    #data.tables[[20]],
    #data.tables[[21]],
    #data.tables[[22]],
    #data.tables[[23]],
    #data.tables[[24]],
    #data.tables[[25]],
    #data.tables[[26]]
)

print("Done correcting")

print(proc.time() - ptm)

corrected.df <- do.call(cbind.data.frame, Xmnn$corrected)
corrected.mat <- as.matrix(t(corrected.df))

write.table(corrected.mat, file = "data/mnn_corrected_pancreas.txt",
            quote = FALSE, sep = "\t")

library(methods)
library(splatter)

getLNormFactors <- function(n.facs, sel.prob, neg.prob, fac.loc, fac.scale) {

    is.selected <- as.logical(rbinom(n.facs, 1, sel.prob))
    n.selected <- sum(is.selected)
    dir.selected <- (-1) ^ rbinom(n.selected, 1, neg.prob)
    facs.selected <- rlnorm(n.selected, fac.loc, fac.scale)
    # Reverse directions for factors that are less than one
    dir.selected[facs.selected < 1] <- -1 * dir.selected[facs.selected < 1]
    factors <- rep(1, n.facs)
    factors[is.selected] <- facs.selected ^ dir.selected

    return(factors)
}

splatSimBatchEffects <- function(sim, params) {
    nGenes <- getParam(params, "nGenes")
    nBatches <- getParam(params, "nBatches")
    batch.facLoc <- getParam(params, "batch.facLoc")
    batch.facScale <- getParam(params, "batch.facScale")
    means.gene <- rowData(sim)$GeneMean

    for (idx in seq_len(nBatches)) {
        batch.facs <- getLNormFactors(nGenes, 1, 0.5, batch.facLoc[idx],
                                        batch.facScale[idx])
        batch.means.gene <- means.gene * batch.facs
        rowData(sim)[[paste0("BatchFacBatch", idx)]] <- batch.facs
    }

    return(sim)
}

sim.groups.A <- splatSimulate(
    batchCells = c(1000), group.prob = c(0.50, 0.50, 0, 0),
    method = "groups", verbose = FALSE
)
write.table(add.Gaussian.noise(counts(sim.groups.A)), 'simulate_nonoverlap_A.txt')

sim.groups.B <- splatSimulate(
    batchCells = c(1000), group.prob = c(0, 0, 0.50, 0.50),
    method = "groups", verbose = FALSE
)
sim.groups.A <- splatSimBatchEffects(sim.groups.A, newSplatParams())

sim.groups.C <- splatSimulate(
    batchCells = c(1000), group.prob = c(0, 0.50, 0.50, 0),
    method = "groups", verbose = FALSE
)
sim.groups.A <- splatSimBatchEffects(sim.groups.A, newSplatParams())

write.table(counts(sim.groups.B), 'simulate_nonoverlap_B.txt')
write.table(counts(sim.groups.C), 'simulate_nonoverlap_C.txt')

library(reticulate)

names = list(
    "data/pancreas/pancreas_multi_celseq2_expression_matrix_table.txt",
    "data/pancreas/pancreas_multi_celseq_expression_matrix_table.txt"
)

datasets <- list()
genes_list <- list()
for (i in 1:length(names)) {
    datasets[[i]] <- t(as.matrix(
        read.table(names[[i]], sep="\t")
    ))
    genes_list[[i]] <- colnames(datasets[[i]])
}

print("Done loading")

ptm <- proc.time()

scanorama <- import('scanorama')

# Integration.
integrated.data <- scanorama$integrate(datasets, genes_list)

print("Done integrating")

print(proc.time() - ptm)
